package com.baeldung.apiservice;

import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.client.RestTemplate;

@Configuration
public class RestTemplateConfig {
    @Bean
    public RestTemplate restTemplate(RestTemplateBuilder builder) {
        return builder.additionalInterceptors((request, body, execution) -> {
                request.getHeaders()
                    .add("X-Request-Id", RequestIdGenerator.getRequestId());

                return execution.execute(request, body);
            })
            .build();
    }
}
