package com.baeldung.properties.additionalproperties;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.jupiter.api.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ActiveProfiles;

@ActiveProfiles("default")
@SpringBootTest(classes = { AdditionalPropertiesTestConfig.class })
public class AdditionalPropertiesFilesIntegrationTest {

    Logger logger = LoggerFactory.getLogger(AdditionalPropertiesFilesIntegrationTest.class);

    @Value("${baeldung.additionalProperty}")
    private String additionalProperty;
    
    @Value("${baeldung.otherProperty}")
    private String otherProperty;

    @Test
    public void givenMultidocumentPropertiesFileWhenBootContextLoadedThenDocumentProcessedCorrectly() {
        assertThat(additionalProperty).isEqualTo("additionalValue2");
        assertThat(otherProperty).isEqualTo("latterValue");
    }
}
