## Spring Security Login

This module contains articles about login mechanisms with Spring Security.

### The Course
The "Learn Spring Security" Classes: http://github.learnspringsecurity.com

### Relevant Articles: 
- [Spring Security Form Login](https://www.baeldung.com/spring-security-login)
- [Spring Security Logout](https://www.baeldung.com/spring-security-logout)
- [Spring HTTP/HTTPS Channel Security](https://www.baeldung.com/spring-channel-security-https)
- [Spring Security – Customize the 403 Forbidden/Access Denied Page](https://www.baeldung.com/spring-security-custom-access-denied-page)
- [Spring Security – Redirect to the Previous URL After Login](https://www.baeldung.com/spring-security-redirect-login)
- [Spring Security Custom AuthenticationFailureHandler](https://www.baeldung.com/spring-security-custom-authentication-failure-handler)
- [Extra Login Fields with Spring Security](https://www.baeldung.com/spring-security-extra-login-fields)
- More articles: [[next -->]](/spring-security-modules/spring-security-web-login-2)

### Build the Project
```
mvn clean install
```

### Run the Project

- Run the application using Maven Cargo plugin.
```
mvn cargo:run
```
- Go to the login page at http://localhost:8082/spring-security-web-login/login.html
- Login using ```user1/user1Pass``` details.