## Spring Thymeleaf 

This module contains articles about Spring with Thymeleaf

### Relevant Articles: 
- [Introduction to Using Thymeleaf in Spring](https://www.baeldung.com/thymeleaf-in-spring-mvc)
- [Thymeleaf: Custom Layout Dialect](https://www.baeldung.com/thymeleaf-spring-layouts)
- [Spring and Thymeleaf 3: Expressions](https://www.baeldung.com/spring-thymeleaf-3-expressions)
- [Spring MVC + Thymeleaf 3.0: New Features](https://www.baeldung.com/spring-thymeleaf-3)
- [How to Work with Dates in Thymeleaf](https://www.baeldung.com/dates-in-thymeleaf)
- [Working with Fragments in Thymeleaf](https://www.baeldung.com/spring-thymeleaf-fragments)
- [JavaScript Function Call with Thymeleaf](https://www.baeldung.com/thymeleaf-js-function-call)
- [[next -->]](../spring-thymeleaf-2)

### Build the Project

mvn clean install

### Run the Project

mvn cargo:run
- **note**: starts on port '8082'

### Security
The user/password required is: user1/user1Pass

### Endpoints

All endpoints start with `http://localhost:8082/spring-thymeleaf`:

- `/dates`
- `/saveStudent`
- `/objects`
- `/fragments`
- `/markup`
- `/params`
- `/other`
- `/function-call`
- `/html`
- `/js`
- `/plain`
- `/layout`